import { Component } from '@angular/core';
import { ProductService1, ProductService2, Product } from '../product.service';

@Component({
  selector: 'app-product2',
  standalone: true,
  imports: [],
  templateUrl: './product2.component.html',
  /* Servicen vaihto komponentissa.
     Tässä "ylikirjoitetaan" konffitiedoston tarjoama ProductService1 useClass -määreellä
     Jos providers-rivin kommentoi pois, käytetään konffitiedoston tarjoamaa serviceä.
  */
  providers: [{ provide: ProductService1, useClass: ProductService2 }],
})
export class Product2Component {
  product: Product;
  // servicen injektio konstruktoriin, useClass ylikirjoittaa servicen
  constructor(private ps: ProductService1) {
    this.product = this.ps.getProduct();
  }
}
